/* *##% 
 * EUGene :: EUGene
 * Copyright (C) 2004 - 2009 CodeLutin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 *
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * ##%*/

package org.nuiton.eugene.models;

import java.util.Map;

/**
 * Model.
 * 
 * @version $Revision: 755 $
 *
 * Mise a jour: $Date: 2009-12-15 00:50:27 +0100 (mar., 15 déc. 2009) $
 * par : $Author: tchemit $
 */
public interface Model {

    /**
     * Plexus role name
     */
    String ROLE_NAME = Model.class.getName();

    /**
     * Returns the name of this model.
     * 
     * @return the name of this model.
     */
    String getName();

    /**
     * Returns the version of this model.
     *
     * @return the version of this model.
     */
    String getVersion();

    /**
     * Returns the tagValues associated with this element.
     * For each entry, the key is the name of the tagValue, the value is the value of the tagValue :-) 
     * 
     * @return a Map containing all tagValues associated with this element
     */
    Map<String, String> getTagValues();

    /**
     * Returns the tagValue corresponding to the given name, or null if the element has no associated tagValue for this name.
     * 
     * @param tagValue tag value key
     * @return the value of the found tagValue, or null if the element has no associated tagValue for this name.
     */
    String getTagValue(String tagValue);

} //Model
