/* *##% 
 * EUGene :: EUGene
 * Copyright (C) 2004 - 2009 CodeLutin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 *
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * ##%*/

package org.nuiton.eugene.models.state;

import java.util.List;

/**
 * StateModelState.java
 *
 * A state, that can be simple or complexe
 * 
 * @see org.nuiton.eugene.models.state.StateModelSimpleState
 * @see org.nuiton.eugene.models.state.StateModelComplexState
 * 
 * @author chatellier
 * @version $Revision: 755 $
 *
 * Last update : $Date: 2009-12-15 00:50:27 +0100 (mar., 15 déc. 2009) $
 * By : $Author: tchemit $
 */
public interface StateModelState {

    /**
     * Get the state name
     * @return state name
     */
    public String getName();

    /**
     * Return the state's transition set
     * @return a list of transition
     */
    public List<StateModelTransition> getTransitions();

    /**
     * State complex status
     * @return true if the state is complex
     */
    public boolean isComplex();
}
